﻿var PesquisarReservaController = ControllerBase.extend({
    ajax: function () {

        var pesquisa = {
            TamanhoPagina: this.pesquisa ? this.pesquisa.PageSize : 1000,
            NumeroPagina: this.pesquisa ? this.pesquisa.ActualPage : 1,
            Codigo: this.model.get('Codigo'),
            CodigoFilial: this.model.get('Filial')
        };
        
        return {
            url: '/Produto/_Reservas',
            type: 'post',
            cache: false,
            contentType: 'application/json',
            data: JSON.stringify({
                pesquisa: pesquisa
            })
        };
    },

    totalQuantidadeReservada: function (model) {
        return model.reduce(function (memo, value) { return memo + value.QuantidadeReservada }, 0);
    },

    totalQuantidadeDeposito: function (model) {
        return model[0].QuantidadeDeposito;
    },

    atualizarTotais: function () {

        $('#td-reserva-pedido').html(this.totalQuantidadeReservada(this.model));

        $('#td-reserva-deposito').html(this.totalQuantidadeDeposito(this.model));

        $('#td-reserva-total').html(this.totalQuantidadeReservada(this.model) + this.totalQuantidadeDeposito(this.model));
    },

    renderizado: function () {


        this.ReservaProdutoView = this.showView({
            region: {
                name: 'reservaProdutoViewRegion',
                selector: '#pesquisar-reserva-produto-region'
            },
            view: {
                type: ReservaProdutoView,
                args: {
                    collection: new Reservas(this.model)
                }
            }
        });

        $('#descricao-produto-estoque-filial').html('<h3>' + this.produto + '</h3>');

        this.atualizarTotais();
    }
});