﻿var AgregadosController = ControllerBase.extend({
    ajax: function() {

        return {
            url: '/Produto/_Agregados',
            type: 'post',
            cache: false,
            data: {
                codigoProduto: this.model.get('CodigoProduto')
            }
        };

    },

    renderizado: function () {        
        this.carregar(this.collection);
        $("#menu-sub-consulta-produtos").hide();
    },

    paginar: function(e) {
        this.pesquisa.ActualPage = e.page;
        this.pesquisar();
    },

    pesquisar: function(data) {

        var pesquisa = this.pesquisa ? this.pesquisa : {
            NumeroPagina: 1,
            TamanhoPagina: 20,
            Codigo: this.model.get('CodigoProduto')
        };

        var self = this;

        global.ajax({
            url: '/Produto/ConsultarAgregados',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify(pesquisa),
            success: function (data) {
                self.carregar(data);
            }
        });
        

    },

    carregar: function(data) {
     
        if (!data || !data.Entities) {
            return;
        }

        this.agregadosView = this.showView({
            region: {
                name: 'agregadosViewRegion',
                selector: '#produtos-agregados-region'
            },
            view: {
                type: AgregadosView,
                args: {
                    model: this.model,
                    collection: new Backbone.Collection(data.Entities),
                    adicionarProdutosCallback: this.adicionarProdutosCallback
                }
            }
        });

        this.paginador = new Paginator({
            container: '#pesquisar-agregados-page-container',
            data: data,
            pageClickCallback: $.proxy(this.paginar, this)
        });

    }

});