﻿var PedidoClienteController = ControllerBase.extend({
    ajax: function () {

        var pesquisa = {
            CodigoProduto: this.model.get('Codigo'),
            CodigoFilial: this.model.get('Filial'),            
            NumeroPagina: 1
        };

        return {
            url: '/Produto/_PedidoCliente',
            type: 'post',
            cache: false,
            contentType: 'application/json',
            data: JSON.stringify({
                pesquisa: pesquisa
            })
        };
    },

    totalQuantidadeNaoEntregue: function (data) {
        return data.Entities.reduce(function (memo, value) { return memo + value.QuantidadeNaoEntregue }, 0);
    },

    atualizarTotal: function (data) {
        $('#td-pedido-cliente-total-nao-entregue').html(this.totalQuantidadeNaoEntregue(data));
    },

    renderizado: function () {
        this.carregar(this.collection);        
    },

    paginar: function (e) {
        this.pesquisar(e);
    },

    pesquisar: function (e) {

        var pesquisa = this.pesquisa ? this.pesquisa : {
            NumeroPagina: 1,
            TamanhoPagina: 10,
            CodigoProduto: this.model.get('Codigo'),
            CodigoFilial: this.model.get('Filial')
        };

        pesquisa.NumeroPagina = e.page;

        var self = this;

        global.ajax({
            url: '/Produto/ConsultarPedidoCliente',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify(pesquisa),
            success: function (data) {
                self.carregar(data);
            }
        });


    },

    carregar: function (data) {

        if (!data || !data.Entities) {
            return;
        }

        this.pedidoClienteView = this.showView({
            region: {
                name: 'pedidoClienteViewRegion',
                selector: '#pedido-cliente-region'
            },
            view: {
                type: PedidoClienteView,
                args: {
                    collection: new Backbone.Collection(data.Entities)
                }
            }
        });        

        this.paginador = new Paginator({
            container: '#page-pedido-cliente-container',
            data: data,
            pageClickCallback: $.proxy(this.paginar, this)
        });

        $('#descricao-produto-pedido-cliente').html('<h3>' + this.produto + '</h3>');

        this.atualizarTotal(data);
    }
});