﻿var $boolSelecionarTodosAgregados = false;

var AgregadosItemView = Backbone.Marionette.ItemView.extend({
    template: '#template-lista-agregados-item',
    tagName: 'tr',
    className: 'clicavel',


    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
    },

    events: {        
        'click td': 'selecionarProduto'
    },

    selecionarProduto: function (e) {

        var cor = $(e.target).parents('tr').css('background-color');        

        if (e.clientX != null) { // Click linha
            if (cor == 'rgb(255, 255, 255)' || cor == 'transparent' || cor == 'rgba(0, 0, 0, 0)') {
                $(e.target).parents('tr').css('background-color', '#FFFFCC');
                this.controller.model = this.model;
                this.parent.adicionarProduto(this.model);
            } else {
                $(e.target).parents('tr').css('background-color', '');
                this.parent.removerProduto(this.model);
            }
        } else { //Selecionar Todos
            if ($boolSelecionarTodosAgregados) {
                if (cor == 'rgb(255, 255, 255)' || cor == 'transparent' || cor == 'rgba(0, 0, 0, 0)') {
                    $(e.target).parents('tr').css('background-color', '#FFFFCC');
                    this.controller.model = this.model;
                    this.parent.adicionarProduto(this.model);
                }
            } else {
                $(e.target).parents('tr').css('background-color', '');
                this.parent.removerProduto(this.model);
            }
        }     
    }

});


var AgregadosView = Backbone.Marionette.CompositeView.extend({
    template: '#template-lista-agregados',
    childView: AgregadosItemView,
    childViewContainer: '#lista-agregados-container',

    initialize: function (options) {
        this.selecionados = new Backbone.Collection();
        this.app = options.app;
        this.parent = options.parent;
        this.adicionarProdutosCallback = typeof options.adicionarProdutosCallback != 'undefined' ? options.adicionarProdutosCallback : null;

        $('#pesquisar-estoque-produto-region').hide();
        $('#produtos-similares-region').hide();
        $('#pesquisar-reserva-produto-container').hide();
        $('#pesquisar-pedido-cliente-container').hide();
        $('#pesquisar-pedido-fornecedor-container').hide();
    },

    events: {
        'click #adicionar-agregados': 'adicionarProdutos',
        'click #selecionar-todos-agregados': 'selecionarTodosAgregados'
    },

    buildChildView: function (item, itemView) {

        var view = new itemView({
            model: item,
            app: this.app,
            parent: this
        });

        if (this.controller) {
            view.controller = this.controller;
        }

        return view;
    },

    adicionarProduto: function (model) {
        this.selecionados.add(model);
    },

    removerProduto: function (model) {
        this.selecionados.remove(model);
    },

    adicionarProdutos: function () {

        if (this.selecionados.length == 0) {
            global.showErrorMessage('Por favor, selecione os produtos a serem adicionados.');
            return;
        }

        if (this.adicionarProdutosCallback) {
            this.adicionarProdutosCallback(this.selecionados.toJSON());
        }        
    },

    selecionarTodosAgregados: function (e) {

        if ($boolSelecionarTodosAgregados)
            $boolSelecionarTodosAgregados = false;
        else
            $boolSelecionarTodosAgregados = true;

        $('#lista-agregados-container td.codigo').trigger('click');
    }

});