﻿var EstoqueProdutoItemView = Backbone.Marionette.ItemView.extend({
    template: '#template-estoque-produto-item',
    tagName: 'tr',
    className: 'clicavel',
    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
        this.estoqueSelecionado = new Backbone.Collection();
    },

    events: {
        //'click a.icone-lista': 'pesquisarReservas',
        'click td': 'selecionar'
    },

    render: function () {

        var data = $.extend(this.model.toJSON(), {
            quantidade: function () {

                if (this.Quantidade == 0)
                    return "";

                return global.formatNumber(this.Quantidade);
            },

            quantidadeDisponivel: function () {

                if (this.QuantidadeDisponivel == 0)
                    return "";

                return global.formatNumber(this.QuantidadeDisponivel);
            },

            quantidadeReservado: function () {

                if (this.QuantidadeReservado == 0)
                    return "";

                return global.formatNumber(this.QuantidadeReservado);
            },

            possuiReserva: function () {
                return this.QuantidadeReservado > 0;
            },

            quantidadeEmTransito: function () {

                if (this.QuantidadeEmTransito == 0)
                    return "";

                return global.formatNumber(this.QuantidadeEmTransito);
            },

            pedidosFornecedor: function () {

                if (this.PedidosFornecedor == 0)
                    return "";

                return global.formatNumber(this.PedidosFornecedor);
            },

            qtdeNaoEntregueExpedicao: function () {

                if (this.QtdeNaoEntregueExpedicao == 0)
                    return "";

                return global.formatNumber(this.QtdeNaoEntregueExpedicao);
            },

            quantidadeNaoEntregueFutura: function () {

                if (this.QuantidadeNaoEntregueFutura == 0)
                    return "";
                
                return global.formatNumber(this.QuantidadeNaoEntregueFutura);
            },

            quantidadeDisponivelLote: function () {

                if (this.QuantidadeDisponivelLote == 0)
                    return "";

                return global.formatNumber(this.QuantidadeDisponivelLote);
            },

            codigo: function () {
                return this.Codigo;
            },

            descricao: function () {
                return this.Descricao;
            },

            r: function () {
                return this.R;
            },

            t: function () {
                return this.T;
            }

        });

        $('#reserva-item-menu').parent().addClass("inativo");
        $('#pedido-cliente-item-menu').parent().addClass("inativo");
        $('#pedido-fornecedor-item-menu').parent().addClass("inativo");

        this.$el.html(Mustache.render($(this.template).html(), data));

    },

    selecionar: function (e) {

        limparSelecaoEstoqueProduto();

        var cor = $(e.target).parents('tr').css('background-color');

        if (cor == 'rgb(255, 255, 255)') {
            $(e.target).parents('tr').css('background-color', '#FFFFCC');
            this.controller.model = this.model;
        } else {
            $(e.target).parents('tr').css('background-color', '');
        }

        if (this.model.get('QuantidadeReservado') > 0) {
            $('#reserva-item-menu').parent().removeClass("inativo");
        } else {
            $('#reserva-item-menu').parent().addClass("inativo");
        }

        $('#pedido-cliente-item-menu').parent().removeClass("inativo");
        $('#pedido-fornecedor-item-menu').parent().removeClass("inativo");
    }
});


var EstoqueProdutoView = Backbone.Marionette.CompositeView.extend({
    template: '#template-estoque-produto',
    childView: EstoqueProdutoItemView,
    childViewContainer: '#lista-estoque-produto-container',

    initialize: function (options) {
        this.app = options.app;
        this.produto = options.produto;

        $('#produtos-agregados-region').hide();
        $('#produtos-similares-region').hide();
        $('#pesquisar-reserva-produto-container').hide();
        $('#pesquisar-pedido-cliente-container').hide();
        $('#pesquisar-pedido-fornecedor-container').hide();
    },

    buildChildView: function (item, itemView) {

        var view = new itemView({
            model: item,
            app: this.app,
            parent: this
        });

        if (this.controller) {
            view.controller = this.controller;
        }


        return view;

    }


});