﻿var PedidoFornecedorItemView = Backbone.Marionette.ItemView.extend({
    template: '#template-listar-pedido-fornecedor-item',
    tagName: 'tr',
    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
        this.controller = options.controller;
    },

    onRender: function () {

        if (this.model.get('PedidoCompraOrcamento') > 0 && this.model.get('QuantidadeNaoEntregue') > 0) {
            this.$el.addClass('cor-2');
        }
        else if (this.model.get('PedidoCompraOrcamento') > 0 && this.model.get('QuantidadeNaoEntregue') == 0) {
            this.$el.addClass('cor-3');
        }
        else if (this.model.get('CodigoOutroOrcamento') > 0 && this.model.get('PedidoCompraOrcamento') > 0 && this.model.get('QuantidadeNaoEntregue') > 0) {
            this.$el.addClass('cor-4');
        }
        else {
            this.$el.addClass('cor-1');
        }
    }
});

var PedidoFornecedorView = Backbone.Marionette.CompositeView.extend({
    template: '#template-listar-pedido-fornecedor',
    childView: PedidoFornecedorItemView,
    childViewContainer: '#lista-pedido-fornecedor-container',

    initialize: function (options) {
        this.app = options.app;
    },

    buildChildView: function (item, itemView) {

        var view = new itemView({
            model: item,
            app: this.app,
            parent: this
        });
        return view;
    }
});