﻿var CompararProdutosController = ControllerBase.extend({
    template: '#template-comparar-produtos',


    ajax: function() {
        return {
            url: '/Produto/_CompararProdutos',
            type: 'get',
            cache: false
        };
    },

    renderizado: function () {        
        $('#_compararProduto-region').html(Mustache.render($(this.template).html(), {
            produtos: this.collection
        }));

        this.obterParametrosInfo(false);
    },

    obterParametrosInfo: function (async) {
        this.obterParametro('EXIBIR_QUANTIDADE_ESTOQUE_CONSULTA_PRODUTOS', async);
        this.obterParametro('EXIBIR_PRECO_COMISSAO_NA_CONSULTA_PRODUTOS', async);
        this.obterParametro('EXIBIR_QUANTIDADE_MINIMA_VENDA_CONSULTA_PRODUTOS', async);
    },

    obterParametro: function (nomeInterno, async) {

        var pesquisa = {
            nomeInterno: nomeInterno
        };

        var self = this;

        global.ajax({
            url: '/Usuario/_ObterParametro',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify(pesquisa),
            async: async,
            success: function (data) {
                self.esconderDiv(pesquisa.nomeInterno, data);
            }
        });
    },

    esconderDiv: function (nomeInterno, valorParametro) {

        switch (nomeInterno) {
            case 'EXIBIR_PRECO_COMISSAO_NA_CONSULTA_PRODUTOS':
                if (valorParametro != 'S')
                    $('#comparar-produtos-region').find('#linha-comissao-venda').remove();
                else
                    $('#comparar-produtos-region').find('#linha-comissao-venda').show();
                break;
            case 'EXIBIR_QUANTIDADE_ESTOQUE_CONSULTA_PRODUTOS':
                if (valorParametro != 'S')
                    $('#comparar-produtos-region').find('#linha-quantidade-disponivel').remove();
                else
                    $('#comparar-produtos-region').find('#linha-quantidade-disponivel').show();
                break;
            case 'EXIBIR_QUANTIDADE_MINIMA_VENDA_CONSULTA_PRODUTOS':
                if (valorParametro != 'S')
                    $('#comparar-produtos-region').find('#linha-quantidade-minima-venda').remove();
                else
                    $('#comparar-produtos-region').find('#linha-quantidade-minima-venda').show();
                break;
        }
    }

});