﻿var FinalizarOrcamentoController = ControllerBase.extend({

    ajax: function () {

        return {
            url: '/Orcamento/_FinalizarOrcamento',
            type: 'get',
            cache: false,
            data: {
                identificadorOrcamento: this.model.get('IdentificadorOrcamento')
            }
        };
    },

    renderizado: function() {
        this.atacharEventos();
        this.alterarExibicao();
    },
    
    alterarExibicao: function() {
        
        if (this.model.get('Numero')) {
            $("#detalhe-finalizar-orcamento-region").hide();
            $("#template-numero-pedido").show();
            var self = this;
            
            self.showView({
                region: {
                    name: 'numeroPedidoViewRegion',
                    selector: '#numero-pedido-region'
                },
                view: {
                    type: NumeroPedidoView,
                    args: {
                        model: this.model
                    }
                }
            });
        }
    },

    atacharEventos: function () {

        $('#finalizar-orcamento').click($.proxy(this.finalizarOrcamento, this));

    },
    
    finalizarOrcamento: function() {

        var self = this;

        global.ajax({
            url: '/Orcamento/Salvar',
            type: 'post',
            cache: false,
            data: {
                identificadorOrcamento: this.model.get('IdentificadorOrcamento')
            },
            success: function(data) {

                data = global.tratarRetorno(data);

               
                if (data && data.Numero) {

                    self.model.set('Numero', data.Numero);
                    
                    $("#menu-esquerdo").hide();
                
                    self.showView({
                        region: {
                            name: 'numeroPedidoViewRegion',
                            selector: '#numero-pedido-region'
                        },
                        view: {
                            type: NumeroPedidoView,
                            args: {
                                model: self.model
                            }
                        }
                    });

                }
            }
        });
    }

});