﻿var FormaPagamentoController = ControllerBase.extend({
    form: '#form-pesquisar-formas-pagamento',

    renderizar: function(renderizacaoCompletaCallback) {

        var self = this;

        var identificadorOrcamento = this.model.get('IdentificadorOrcamento');
        var codigoFormaPagamento = this.model.get('CodigoFormaPagamento');
        var codigoTipoDocumento = this.model.get('CodigoTipoDocumento');

        global.ajax({
            url: '/Orcamento/_FormaPagamento',
            type: 'get',
            cache: false,
            data: {
                identificadorOrcamento: identificadorOrcamento,
                codigoFormaPagamento: codigoFormaPagamento,
                codigoTipoDocumento: codigoTipoDocumento
            },
            success: function(data) {
                $(self.container).show();
                $(self.container).empty();
                $(self.container).html(data);

                if (renderizacaoCompletaCallback) {
                    renderizacaoCompletaCallback();
                }

            }
        });
    },

    renderizado: function() {
        this.atacharEventos();
        $('#formaPagamento').focus();
    },

    atacharEventos: function() {

        $('select[name=formaPagamento]').change($.proxy(this.formaPagamentoAlterada, this));
        $('select[name=tiposDocumento]').change($.proxy(this.tipoDocumentoAlterado, this));

        this.addActionButton({
            text: 'Limpar',
            'class': 'icone-excluir separador',
            click: $.proxy(function () {
                this.model.unset('CodigoFormaPagamento');
                this.model.unset('CodigoTipoDocumento');
                $('select[name=formaPagamento] option[value=""]').prop('selected', true);
                $('#lista-tipo-documento').empty();
                this.resetRegion('parcelasViewRegion');
                
                var identificadorOrcamento = this.model.get('IdentificadorOrcamento');

                this.atualizarFormaPagamento(identificadorOrcamento, 0, 0);

                global.ajax({
                    blockUI: false,
                    url: '/Orcamento/ObterTotaisOrcamento',
                    type: "post",
                    contentType: 'application/json',
                    data: JSON.stringify({
                        identificadorOrcamento: this.model.get('IdentificadorOrcamento')
                    }),
                    success: function (data) {
                        data = global.tratarRetorno(data);

                        if (data) {
                            if (this.model != null) {
                                this.model.set('ValorTotalMercadorias', data.ValorTotalMercadorias);
                                this.model.set('ValorTotal', data.ValorTotal);
                            }
                        }
                    }
                });

            }, this)
            
        }, true);

    },
    


    selecionarTipoDocumento: function(codigoTipoDocumento) {
        $('select[name=tiposDocumento] option[value=' + codigoTipoDocumento + ']').prop('selected', true);
    },

    formaPagamentoAlterada: function (e) {

        var $tiposDocumento = $('#lista-tipo-documento');
        $tiposDocumento.empty();
        this.resetRegion('parcelasViewRegion');

        var codigoFormaPagamento = $(e.target).val();

        if (!codigoFormaPagamento) {
            this.model.unset('CodigoFormaPagamento');
            return;
        }

        var identificadorOrcamento = this.model.get('IdentificadorOrcamento');
        this.model.set('CodigoFormaPagamento', codigoFormaPagamento);

        this.atualizarFormaPagamento(identificadorOrcamento, codigoFormaPagamento, null);

        global.ajax({
            url: '/Orcamento/TiposDocumento',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: identificadorOrcamento,
                codigoFormaPagamento: codigoFormaPagamento
            }),
            success: function(data) {

                var option = $('<option>');
                option.html('Selecione');
                $tiposDocumento.append(option);

                if (data && data.length > 0) {
                    $.each(data, function() {
                        option = $('<option>', {
                            value: this.Codigo
                        });
                        option.html(this.Descricao);
                        $tiposDocumento.append(option);
                    });
                }

            }
        });

    },

    mostrarParcelas: function(parcelas) {
      
        this.parcelaView = this.showView({
            region: {
                name: 'parcelasViewRegion',
                selector: '#parcelas-region'
            },
            view: {
                type: ParcelaView,
                args: {
                    model: this.model,
                    collection: new Parcelas(parcelas)
                }
            }
        });

    },

    tipoDocumentoAlterado: function (e) {

        var codigoTipoDocumento = $(e.target).val();

        if (!codigoTipoDocumento) {
            this.model.unset('CodigoTipoDocumento');
            return;
        }

        this.model.set('CodigoTipoDocumento', codigoTipoDocumento);

        var self = this;

        var identificadorOrcamento = this.model.get('IdentificadorOrcamento');
        var codigoFormaPagamento = this.model.get('CodigoFormaPagamento');

        this.atualizarFormaPagamento(identificadorOrcamento, codigoFormaPagamento, codigoTipoDocumento);
    },

    atualizarFormaPagamento: function(identificadorOrcamento, codigoFormaPagamento, codigoTipoDocumento) {

        var self = this;

        global.ajax({
            url: '/Orcamento/AtualizaFormaPagamento',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: identificadorOrcamento,
                codigoFormaPagamento: codigoFormaPagamento,
                codigoTipoDocumento: codigoTipoDocumento
            }),
            success: function (data) {

                data = global.tratarRetorno(data);

                self.model.atualizarTotaisOrcamento();

                if (data && data.length > 0) {
                    self.mostrarParcelas(data);
                }
            }
        });
    }

});