﻿var MenuConsultaProdutosController = ObjectBase.extend({

    show: function () {
        this.atacharEventos();
        $("#menu-consulta-produtos").show();
    },

    hide: function () {
        $("#menu-consulta-produtos").hide();
        $("#menu-sub-consulta-produtos").hide();
    },

    atacharEventos: function () {

        $("#estoque-item-menu").unbind();
        $("#estoque-item-menu").click($.proxy(this.pesquisarEstoque, this));

        $("#agregados-item-menu").unbind();
        $("#agregados-item-menu").click($.proxy(this.pesquisarAgregados, this));

        $("#similares-item-menu").unbind();
        $("#similares-item-menu").click($.proxy(this.pesquisarSimilares, this));

    },

    obterModel: function () {
        if (this.obterModelCallback) {
            this.model = this.obterModelCallback();
        }

    },

    pesquisarEstoque: function () {

        this.obterModel();

        if (!this.model) {
            global.showErrorMessage('Selecione um produto antes de consultar o estoque.');
            return;
        }

        this.pesquisarEstoqueItemController = this.controller.showView({
            region: {
                name: 'estoqueProdutoRegion',
                selector: '#pesquisar-estoque-produto-container'
            },
            controller: {
                type: PesquisarEstoqueController,
                args: {
                    model: this.model
                }
            },
            success: function () {
                limparSelecaoEstoqueProduto();
                $("menu-sub-consulta-produtos").show();
            }
        });

        if ($('#pesquisar-estoque-produto-region').is(":visible") || $('[regionname=estoqueProdutoViewRegion]').is(':visible'))
        { $('#mostrar-historico-filtro').hide(); }

    },

    pesquisarAgregados: function () {

        this.obterModel();

        if (!this.model) {
            global.showErrorMessage('Selecione um produto antes de consultar os produtos agregados.');
            return;
        }

        //$('#tabela-itens-orcamento-region td.selecionavel').parents('tr').css('background-color', '');

        //this.controller.orcamentoController.model.get('ItensOrcamento').each(function (model) {
        //    model.set('selecionado', false);
        //});


        this.agregadosController = this.controller.showView({
            region: {
                name: 'agregadosControllerRegion',
                selector: '#pesquisar-agregados-produto-container'
            },
            controller: {
                type: AgregadosController,
                args: {
                    model: this.model,
                    adicionarProdutosCallback: $.proxy(this.adicionarProdutosCallback, this)
                }
            },
            success: function () {
                limparSelecaoEstoqueProduto();
                $("#menu-sub-consulta-produtos").hide();

                if (this.pesquisarEstoqueItemController != null)
                    this.pesquisarEstoqueItemController.hide();

                if (this.similaresController != null)
                    this.similaresController.hide();
            }
        });

        if ($('#pesquisar-estoque-produto-region').is(":visible") || $('[regionname=estoqueProdutoViewRegion]').is(':visible'))
        { $('#mostrar-historico-filtro').hide(); }

    },

    pesquisarSimilares: function () {

        this.obterModel();

        if (!this.model) {
            global.showErrorMessage('Selecione um produto antes de consultar os produtos similares.');
            return;
        }

        this.similaresController = this.controller.showView({
            region: {
                name: 'similaresControllerRegion',
                selector: '#pesquisar-similares-produto-container'
            },
            controller: {
                type: SimilaresController,
                args: {
                    model: this.model,
                    adicionarProdutosCallback: $.proxy(this.adicionarProdutosCallback, this)
                }
            },
            success: function () {
                limparSelecaoEstoqueProduto();
                $("#menu-sub-consulta-produtos").hide();

                if (this.agregadosController != null)
                    this.agregadosController.hide();

                if (this.pesquisarEstoqueItemController != null)
                    this.pesquisarEstoqueItemController.hide();
            }
        });

        if ($('#pesquisar-estoque-produto-region').is(":visible") || $('[regionname=estoqueProdutoViewRegion]').is(':visible'))
        { $('#mostrar-historico-filtro').hide(); }
    }

});