﻿var ItemOrcamento = Backbone.Model.extend({

    initialize: function () {

       
        this.on('change:Quantidade', this.itemAlterado, this);
    },

    alterarQuantidade: function(quantidade, callback) {
      
        var self = this;

        var jsonData = this.toJSON();
        jsonData.Quantidade = quantidade;

        global.ajax({
            url: '/Orcamento/EditarItem',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: this.get('IdentificadorOrcamento'),
                item: jsonData
            }),
            success: function (data) {

                var error = false;

                if (data) {

                    self.off('change:Quantidade');
                    self.set('Quantidade', data.Quantidade);
                    self.on('change:Quantidade', self.itemAlterado, self);

                    if (data.IdentificadorErro) {
                        error = true;
                        global.showErrorMessage(data.IdentificadorErro);
                    }
                    
                    self.set('ValorTotal', data.ValorTotal);
                }

                if (self.orcamento) {
                    self.orcamento.atualizarTotaisOrcamento();
                }

                if (!error && callback) {
                    callback();
                }

            },

        });

    },

    itemAlterado: function () {

        var self = this;

        global.ajax({
            url: '/Orcamento/EditarItem',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: this.get('IdentificadorOrcamento'),
                item: this.toJSON()
            }),
            success: function (data) {

                if (data) {
                    
                    if (data.IdentificadorErro) {
                        self.off('change:Quantidade');
                        self.set('Quantidade', data.Quantidade);
                        self.on('change:Quantidade', self.itemAlterado, self);
                        global.showErrorMessage(data.IdentificadorErro);
                    }

                    self.set('ValorTotal', data.ValorTotal);
                }

                if (self.orcamento) {
                    self.orcamento.atualizarTotaisOrcamento();
                }

            },
            
        });
    },

    excluir: function() {

        var excluido = false;

        global.ajax({
            url: '/Orcamento/ExcluirItem',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: this.get('IdentificadorOrcamento'),
                item: this.toJSON()
            }),
            async: false,
            success: function (data) {

                data = global.tratarRetorno(data);

                if (data) {
                    excluido = true;
                }
            }
        });

        return excluido;

    }


});

var ItensOrcamento = Backbone.Collection.extend({
    model: ItemOrcamento
});