﻿var Orcamento = Backbone.Model.extend({
    initialize: function() {
        this.on('change:CodigoCliente', this.clienteAlterado, this);
        this.on('change:ItensOrcamento', this.atualizarTotaisOrcamento, this);
        this.criarItensOrcamento();

    },

    criarItensOrcamento: function() {
        if (!this.get('ItensOrcamento')) {
            var itensOrcamento = new ItensOrcamento();
            itensOrcamento.orcamento = this;
            this.set('ItensOrcamento', itensOrcamento);
        }
    },

    adicionarItens: function(itens) {

        if (!itens || itens.length == 0) {
            return;
        }

        this.criarItensOrcamento();
        
        var itensOrcamento = this.get('ItensOrcamento');

        var self = this;

        global.ajax({
            url: '/Orcamento/AdicionarItens',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: this.get('IdentificadorOrcamento'),
                produtos: itens
            }),
            success: function (data) {

                data = global.tratarRetorno(data);

                itensOrcamento.reset();

                if (data && data.length > 0) {
                    $.each(data, function () {
                        var item = itensOrcamento.add(this);
                        item.orcamento = self;
                    });
                }

                self.atualizarTotaisOrcamento();
            }
        });
    },

    selecionarCliente: function(cliente) {

        if (!this.get('Cliente')) {
            this.set('Cliente', cliente);
        }
    },

    clienteAlterado: function () {

        if (this.get('CodigoCliente')) {
            global.ajax({
                blockUI: false,
                url: '/Orcamento/AtualizarCliente',
                type: "post",
                contentType: 'application/json',
                data: JSON.stringify({
                    identificadorOrcamento: this.get('IdentificadorOrcamento'),
                    codigoCliente: this.get('CodigoCliente')
                })
            });
        }
    },

    atualizarTotaisOrcamento: function() {

        var self = this;
        
        global.ajax({
            blockUI: false,
            url: '/Orcamento/ObterTotaisOrcamento',
            type: "post",
            contentType: 'application/json',
            data: JSON.stringify({
                identificadorOrcamento: this.get('IdentificadorOrcamento')
            }),
            success: function(data) {
                data = global.tratarRetorno(data);

                if (data) {
                    self.set('ValorTotalMercadorias', data.ValorTotalMercadorias);
                    self.set('ValorTotal', data.ValorTotal);
                }

            }
        });

    }

});
