﻿var EditarItemOrcamentoView = Backbone.Marionette.CompositeView.extend({
    template: '#template-editar-item-orcamento',
    form: '#form-editar-item-orcamento',
    
    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
        this.finalizarEdicaoItemCallback = options.finalizarEdicaoItemCallback;
        this.cancelarEdicaoItemCallback = options.cancelarEdicaoItemCallback;
    },
    
    ui: {
        quantidade: 'input[name=Quantidade]'
    },

    events: {
        'click #aplicar-editar-item-orcamento': 'aplicar'
    },

    onShow: function() {
        this.configurarForm();
        this.ui.quantidade.focus();
    },

    configurarForm: function() {
        

        this.validationOptions = {
            errorClass: 'obrigatorio',
            onkeyup: false,
            errorPlacement: function (error, element) {
                return true;
            },
            focusInvalid: false,
            invalidHandler: function (event, validator) {

                var errors = validator.numberOfInvalids();

                if (errors) {
                    var messages = new Array();

                    $.each(validator.errorList, function () {
                        messages.push(this.message);
                    });

                    global.showErrorMessage(messages);

                    return false;
                }
            },
            rules: {
                 'Quantidade': {
                     required: true
                 }
            },
            messages: {
                'Quantidade': {
                    required: 'O campo "quantidade" é obrigatório.'                }
            }
        };

        $(this.form).validate(this.validationOptions);

    },

    aplicar: function() {
        
        if (!$(this.form).valid()) {
            return false;
        }

        var formdata = global.convertFormToJSON({
            element: $(this.form)
        });

        this.model.alterarQuantidade(formdata.Quantidade, $.proxy(this.quantidadeAlterada, this));
    },

    quantidadeAlterada: function () {

        global.showSuccessMessage('Item alterado com sucesso.');
        

        if (this.finalizarEdicaoItemCallback) {
            this.finalizarEdicaoItemCallback();
        }
    }


});