﻿var $boolSelecionarTodosItensOrcamento = false;

var ItemOrcamentoItemView = Backbone.Marionette.ItemView.extend({
    template: '#template-itens-orcamento-item',
    tagName: 'tr',
    className: 'clicavel',

    events: {
        'click td.selecionavel': 'selecionarItem',
        'click a[editar]': 'editarItem',
        'click a[info]': 'showInfo'
    },

    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
    },

    selecionarItem: function (e) {

        var cor = $(e.target).parents('tr').css('background-color');

        if (e.clientX != null) { // Click linha
            if (cor == 'rgb(255, 255, 255)' || cor == 'transparent' || cor == 'rgba(0, 0, 0, 0)') {
                $(e.target).parents('tr').css('background-color', '#FFFFCC');                
                this.model.set('selecionado', true);
            } else {
                $(e.target).parents('tr').css('background-color', '');
                this.model.set('selecionado', false);
            }
        } else { //Selecionar Todos
            if ($boolSelecionarTodosItensOrcamento) {
                if (cor == 'rgb(255, 255, 255)' || cor == 'transparent' || cor == 'rgba(0, 0, 0, 0)') {
                    $(e.target).parents('tr').css('background-color', '#FFFFCC');                    
                    this.model.set('selecionado', true);
                }
            } else {
                $(e.target).parents('tr').css('background-color', '');
                this.model.set('selecionado', false);
            }
        }

        this.itemSelecionado();
    },

    itemSelecionado: function (e) {

        this.parent.habilitarBotoes();

    },

    editarItem: function (e) {
        this.parent.editarItem(this.model);
    },


    showInfo: function () {

        this.itemOrcamentoInfoView = this.controller.showView({
            region: {
                name: 'itemOrcamentoInfoViewRegion',
                selector: '#detalhe-item-orcamento-region'
            },
            view: {
                type: ItemOrcamentoInfoView,
                args: {
                    controller: this.controller,
                    model: this.model
                }
            }
        });
    }

});


var ItemOrcamentoInfoView = Backbone.Marionette.ItemView.extend({
    template: '#template-itens-orcamento-info',

    initialize: function (options) {
        this.app = options.app,
        this.parent = options.parent,
        this.model = options.model;
        this.controller = options.controller;
        this.menuConsultaProdutosController = new MenuConsultaProdutosController({
            controller: this.controller,
            model: this.model
        });        
    },

    onShow: function () {
        this.menuConsultaProdutosController.show();
        this.controller.obterParametrosInfo(false);
    },

    onDestroy: function () {
        this.menuConsultaProdutosController.hide();
    }
});

var ItemOrcamentoView = Backbone.Marionette.CompositeView.extend({
    template: '#template-itens-orcamento',
    childView: ItemOrcamentoItemView,
    childViewContainer: '#lista-itens-orcamento-container',

    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
        this.collection.on('change:Quantidade', this.render, this);
        this.collection.on('change:ValorTotal', this.render, this);

        $('#selecionar-todos-itens-orcamento').click($.proxy(this.selecionarTodosItemOrcamento, this));
    },

    buildChildView: function (item, itemView) {

        var view = new itemView({
            model: item,
            app: this.app,
            parent: this,
            controller: this.controller
        });

        if (this.controller) {
            view.controller = this.controller;
        }

        return view;
    },

    editarItem: function (item) {
        this.parent.editarItem(item);
    },

    habilitarBotoes: function () {
        this.parent.habilitarBotoes();
    },

    selecionarTodosItemOrcamento: function (e) {

        if ($boolSelecionarTodosItensOrcamento)
            $boolSelecionarTodosItensOrcamento = false;
        else
            $boolSelecionarTodosItensOrcamento = true;

        $('#lista-itens-orcamento-container td.selecionavel.codigo').trigger('click');
    },

    removerSelecao: function (e) {
        $('input:checkbox', this.$el).prop('checked', false);
    }
});