﻿var ClienteItemView = Backbone.Marionette.ItemView.extend({
    template: '#template-listar-clientes-item',
    tagName: 'tr',
    className: '',


    initialize: function (options) {
        this.app = options.app;
        this.parent = options.parent;
    },

    events: {
        'click td': 'selecionar'
       
    },
    
    selecionar: function (e) {
        this.parent.clienteSelecionado(this.model);
    }
});


var ClienteView = Backbone.Marionette.CompositeView.extend({
    template: '#template-listar-clientes',
    childView: ClienteItemView,
    childViewContainer: '#lista-clientes-container',

    initialize: function (options) {
        this.app = options.app;
        this.clienteSelecionadoCallbackView = options.clienteSelecionadoCallbackView;
        this.clienteLimparCallback = options.clienteLimparCallback;
        
    },

    events: {
        'click #button-limpar-cliente-selecionado' : 'limparCliente'
    },

    buildChildView: function (item, itemView) {

        var view = new itemView({
            model: item,
            app: this.app,
            parent: this
        });
        return view;
    },

    clienteSelecionado: function (cliente) {

        
        if (!cliente || !this.clienteSelecionadoCallbackView) {
            return;
        }

        this.clienteSelecionadoCallbackView(cliente);
    },

    limparCliente: function () {

        if (!this.clienteLimparCallback) {
            return;
        }

        this.clienteLimparCallback();
    }

});

    